/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * fische-3.1
 * Copyright (C) Marcel Ebmer 2009-2010 <marcel@26elf.at>
 *
 * fische-3.1 is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * fische-3.1 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CONFIGURATION_H
#define CONFIGURATION_H

class Configuration {
	private:
		static Configuration* ms_instance;
		Configuration (int, char**);
		~Configuration();

	public:
		enum {ALSA, PULSE, DUMMY, PORTAUDIO};
		int fpsTarget() const;
		const char* device() const;
		int X() const;
		int Y() const;
		int screenX() const;
		int screenY() const;
		bool fullscreen() const;
		bool multiThreaded() const;
		bool exitOnMouse() const;
		void toggleFullscreen();
		int audioDriver() const {
			return __audioDriver;
		}

		static Configuration* instance (int count = 0, char** args = 0);
		void release();

	private:
		const char* __alsaDevice;
		int __vecX;
		int __vecY;
		int __virtX;
		int __virtY;
		bool __fs;
		int __fps;
		bool __MT;
		bool __eom;
		int __audioDriver;
		bool __writeConfig;
		void help();
		void set_geometry (char*);
		void set_virtual (char*);
		void set_device (char*);
		void set_driver (char*);
		void set_fullscreen (char*);
		void set_fps (char*);
		void set_single (char*);
		void set_eom (char*);
		void read_configfile();
		bool __eom_in_cfile, __single_in_cfile;
		void write_configfile();

};

#endif // CONFIGURATION_H
