/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * fische-3.1
 * Copyright (C) Marcel Ebmer 2009-2010 <marcel@26elf.at>
 * 
 * fische-3.1 is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 * 
 * fische-3.1 is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef DRIVER_H
#define DRIVER_H

#ifdef HAVE_CONFIG_H
	#include "config.h"
	#ifdef HAVE_ALSA_ASOUNDLIB_H
		#ifdef HAVE_LIBASOUND
			#define HAVE_ALSA
		#endif
	#endif
	#ifdef HAVE_PULSE_SIMPLE_H
		#ifdef HAVE_LIBPULSE_SIMPLE
			#define HAVE_PULSE
		#endif
	#endif
	#ifdef HAVE_PORTAUDIO_H
		#ifdef HAVE_LIBPORTAUDIO
			#define HAVE_PORTAUDIO
		#endif
	#endif

// without config.h assume ALSA and Pulse present
#else // HAVE_CONFIG_H
	#define HAVE_ALSA
	#define HAVE_PULSE
	#define HAVE_PORTAUDIO
#endif // HAVE_CONFIG_H

// on windows or OSX - no autodetection.
#if defined(WINDOWS_BUILD) || defined(OSX_BUILD)
	#undef HAVE_ALSA
	#undef HAVE_PULSE
	#define HAVE_PORTAUDIO
#endif // WINDOWS_BUILD

#endif // DRIVER_H
	